package main.java;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;
import java.util.function.Function;

public class ItemTypeProviderBuilder {
    private final List<Function<Object, Class<?>>> itemTypeProvider = new ArrayList<>();

    public ItemTypeProviderBuilder provideItemType(Function<Object, Class<?>> itemTypeProvider) {
        this.itemTypeProvider.add(itemTypeProvider);
        return this;
    }

    public Function<Object, Class<?>> build() {
        return item -> itemTypeProvider.stream().
                map(f -> f.apply(item)).
                filter(Objects::nonNull).
                findFirst().orElse(null);
    }
}
